# -*- coding: cp1250 -*-
from PIL import Image
import pygame, sys, os, time, random, urllib
from pygame.locals import *

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!Filip Dobrovolny 2013 (c)     !
#!To start press F5 in IDLE     !
#!Pro spusteni zmackni F5 v IDLE!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

def downloadImages(): # stahne vsechny obrazky mapy pro dane piblen
    global vodorovne, svisle, zoom, directory
    vodorovne = 3 * 2 ** zoom
    svisle = 2 * 2 ** zoom
    directory = "temp/" + server + ":" + str(port)+ "/" + str(zoom)
    if not os.path.exists(directory) : os.makedirs(directory)
    for x in range(0, vodorovne):
        if not os.path.exists(directory + "/" + str(x)) : os.makedirs(directory + "/" + str(x))
        for y in range(0, svisle):
            if not os.path.exists(directory + "/" + str(x) + "/" + str(y) + ".jpg"):
                try:
                    f = open(directory + "/" + str(x) + "/" + str(y) + ".jpg","wb")
                    f.write(urllib.urlopen("http://" + server + ":" + str(port) + "/" + str(zoom) + "/" + str(x) + "/" + str(y) + ".jpg").read())
                    f.close()
                    toBMP(directory + "/" + str(x) + "/" + str(y))
                    os.remove(directory + "/" + str(x) + "/" + str(y) + ".jpg")
                except:
                    print("no Images on" + str(x) + " " + str(y))


def downloadNearImages(): #stahne nejblich 16 obrzk
    global zoom, directory, pos
    Xstart = pos[0]
    Ystart = pos[1]
    directory = "temp/" + server + ":" + str(port)+ "/" + str(zoom)
    if not os.path.exists(directory) : os.makedirs(directory)
    for x in range(Xstart - 3, Xstart + 6):
        if not os.path.exists(directory + "/" + str(x)) : os.makedirs(directory + "/" + str(x))
        for y in range(Ystart - 3, Ystart + 6):
            if not os.path.exists(directory + "/" + str(x) + "/" + str(y) + ".bmp"):
                try:
                    f = open(directory + "/" + str(x) + "/" + str(y) + ".jpg","wb")
                    f.write(urllib.urlopen("http://" + server + ":" + str(port) + "/" + str(zoom) + "/" + str(x) + "/" + str(y) + ".jpg").read())
                    f.close()
                    toBMP(directory + "/" + str(x) + "/" + str(y))
                    os.remove(directory + "/" + str(x) + "/" + str(y) + ".jpg")
                except:
                    print("no Images on" + str(x) + " " + str(y))
    
                
def toBMP(file): #Pygame nejak nefunguje s JPG tak si to pevedeme do BMP
    file_in = file + ".jpg"
    img = Image.open(file_in)
    file_out = file + ".bmp"
    img.save(file_out)


def showMap():
    global zoom, vodorovne, svisle, pos, window, directory
    #RADEK 1
    temp = pygame.Rect(window.get_rect().left, window.get_rect().top, box, box)
    temp2 = pygame.Rect(window.get_rect().left + box, window.get_rect().top, box, box)
    temp3 = pygame.Rect(window.get_rect().left + box * 2, window.get_rect().top, box, box)
    if os.path.exists(directory + "/" + str(pos[0]) + "/" + str(pos[1]) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0]) + "/" + str(pos[1]) + ".bmp"), temp)
    if os.path.exists(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1]) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1]) + ".bmp"), temp2)
    if os.path.exists(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1]) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1]) + ".bmp"), temp3)
    #RADEK 2
    temp4 = pygame.Rect(window.get_rect().left, window.get_rect().top + box, box, box)
    temp5 = pygame.Rect(window.get_rect().left + box, window.get_rect().top + box, box, box)
    temp6 = pygame.Rect(window.get_rect().left + box * 2, window.get_rect().top + box, box, box)
    if os.path.exists(directory + "/" + str(pos[0]) + "/" + str(pos[1] + 1) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0]) + "/" + str(pos[1] + 1) + ".bmp"), temp4)
    if os.path.exists(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1] + 1) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1] + 1) + ".bmp"), temp5)
    if os.path.exists(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1] + 1) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1] + 1) + ".bmp"), temp6)
    #RADEK 3
    temp7 = pygame.Rect(window.get_rect().left, window.get_rect().top + box * 2, box, box)
    temp8 = pygame.Rect(window.get_rect().left + box, window.get_rect().top + box * 2, box, box)
    temp9 = pygame.Rect(window.get_rect().left + box * 2, window.get_rect().top + box * 2, box, box)
    if os.path.exists(directory + "/" + str(pos[0]) + "/" + str(pos[1] + 2) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0]) + "/" + str(pos[1] + 2) + ".bmp"), temp7)
    if os.path.exists(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1] + 2) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 1) + "/" + str(pos[1] + 2) + ".bmp"), temp8)
    if os.path.exists(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1] + 2) + ".bmp") : window.blit(pygame.image.load(directory + "/" + str(pos[0] + 2) + "/" + str(pos[1] + 2) + ".bmp"), temp9)


def createWindowProp():
    global box, window_width, window_height, fps, fpsClock, font, window
    box = 256
    window_width = box * 3
    window_height = box * 2
    font = pygame.font.SysFont("arial", window_width/40)
    fpsClock = pygame.time.Clock()
    fps = 30
    window = pygame.display.set_mode((window_width, window_height), 0, 32)
    pygame.display.set_caption("Map")
	
    
################################################x
WHITE = (255, 255, 255)
global pos, zoom, server, port, debug
debug = False
#Vypsani zakladnich udaju o aplikaci
print(u"Vtejte v Mapach v. 1.0")
print(u"Vytvoreno Filipem Dobrovolnm 2013 (c)")
print(u"Soutc 39")
print(u"--------------------------------------")
print(u"Ovladani:")
print(u"    ESC - konec programu")
print(u"    ipka dol - posun mapy o 256 px smrem dol")
print(u"    ipka nahor - posun mapy o 256 px smrem nahor")
print(u"    ipka doleva - posun mapy o 256 px smrem doleva")
print(u"    ipka vpravo - posun mapy o 256 px smrem vpravo")
print(u"    +/1 - priblizeni mapy o jednu uroven")
print(u"    -/_ - oddaleni mapy o jednu uroven")
print(u"    f - zadani pozice kter ma byt zobrazena")
server = raw_input("ipAddr(bez portu)(ENTER = 192.168.2.76): ")
if server == "":
    server = "192.168.2.76"
port = raw_input("port(ENTER = 80): ")
if port == "":
    port = 80
else:
    port = int(port)
print(u"Spoutm Program...")
print("__________________________________________________________")
print("==========================================================")
print("__________________________________________________________")
zoom = 0
if debug == True:
    server = "192.168.2.76"
    port = 80
    zoom = 0
downloadImages()
pos = [0, 0]
pygame.init()
createWindowProp()
	
running = True
while running == True:
    for event in pygame.event.get():
        if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
            pygame.quit()
            running = False
        if event.type == KEYDOWN:
            if (event.key == K_DOWN):
                pos[1] = pos[1] + 1
                if zoom > 3:
                    downloadNearImages()
            if (event.key == K_UP):
                if not pos[1] == 0:
                    pos[1] = pos[1] - 1
                else:
                    print("Nelze")
                if zoom > 3:
                    downloadNearImages()
            if (event.key == K_RIGHT):
                pos[0] = pos[0] + 1
                if zoom > 3:
                    downloadNearImages()
            if (event.key == K_LEFT):
                if not pos[0] == 0:
                    pos[0] = pos[0] - 1
                else:
                    print("Nelze")
                if zoom > 3:
                    downloadNearImages()
            if (event.key == K_PLUS):
                global zoom
                if not zoom + 1 == 10:
                    zoom = zoom + 1
                    pos[0] = pos[0] * 2
                    pos[1] = pos[1] * 2
                    if not zoom > 3:
                        downloadImages()
                    else:
                        downloadNearImages()
                    print("Aktualni priblizeni: " + str(zoom))
                else:
                    print("Nelze")
            if (event.key == K_MINUS):
                global zoom
                if not zoom == 0:
                    zoom = zoom - 1
                    pos[0] = pos[0] / 2
                    pos[1] = pos[1] / 2
                    if zoom < 3:
                        downloadImages()
                    else:
                        downloadNearImages()
                    print("Aktualni priblizeni: " + str(zoom))
                else:
                    print("Nelze")
            if (event.key == K_f):
                print("Vyhledavani:")
                print("-------------")
                zoom = raw_input("Priblizeni: ")
                pos[0] = int(raw_input("Pozice X: "))
                pos[1] = int(raw_input("Pozice Y: "))
                    
                
    window.fill(WHITE)
    showMap()
    pygame.display.update()
    fpsClock.tick(fps)
