# -*- coding: cp1250 -*-
import pygame, sys, time, random
from pygame.locals import *
import random as rand
pygame.init()

def nactiZaklad():
	global mod
	print("Zvolte mód:")
	print("           1)Editace bludiště")
	print("           2)Spustit bludiětě")
	mod = raw_input(": ")
	soubor = raw_input("Zadejte název načítaného souboru(vstup1.ln): ")
	soubor = open("vstup1.in", "r")
	text = soubor.read().rstrip()
	soubor.close()
	return prectiSoubor(text)


def prectiSoubor(text):
	global vyska_pole, sirka_pole, box_width, box_height
	text = text.split("\n")
	
	text[0] = text[0].split(" ")
	vyska_pole = int(text[0][1]) + 2
	sirka_pole = int(text[0][0]) + 2 
	del text[0]
	
	box_width = window_width/sirka_pole
	box_height = window_height/vyska_pole
	
	if box_width <= 5 or box_height <= 5:
		print("Nelze Vykreslit")
		sys.exit()
	elif vyska_pole > 82 or sirka_pole > 82:
		print("POZOR pole je vetší než může být, ale nebrání to běhu programu.")
	
	if len(text[0]) != sirka_pole - 2:
		print("Spatna sirka pole zadano " + str(sirka_pole - 2) + " ale je to " + str(len(text[0])))
		sys.exit()
	if len(text) != vyska_pole - 2:
		print("Spatna vyska pole zadano " + str(vyska_pole - 2) + " ale je to " + str(len(text)))
		sys.exit()
	
	vystup = [["X"]*sirka_pole]		
	for y in text:
		radek = ["X"]
		for x in y:
			radek.append(x)
		radek.append("X")
		vystup.append(radek)
	vystup.append(["X"]*sirka_pole)
	print(vystup)
	return nactiBludiste(vystup)
	

def nactiBludiste(vstup):
	global zdi, bilaPani, televize
	zdi = []
	bilaPani = []
	televize = []
	for y in range(vyska_pole):
		for x in range(sirka_pole):
			temp = vstup[y][x]
			coord = [y, x]
			
			if temp == "#":
				televize = coord
			elif temp == "X":
				zdi.append(coord)
			elif temp == "&":
				bilaPani = coord
	print(zdi)
	print(bilaPani)
	print(televize)
	if bilaPani != [] and televize != [] and mod != 1:
		return True, 0, "OK"
	elif bilaPani == []:
		print("Nebyla nalezena Bílá paní")
	else:
		print("Nebyla nalezena Televize")


def getDirection():
	if televize[0] > bilaPani[0]:
		if (televize[0] - bilaPani[0]) < (televize[1] - bilaPani[1]):
			direction = "right"
		elif (televize[0] - bilaPani[0]) < (bilaPani[1] - televize[1]):
			direction = "left"
		else:
			direction = "down"
	elif televize[0] < bilaPani[0]:
		if (bilaPani[0] - televize[0]) < (televize[1] - bilaPani[1]):
			direction = "right"
		elif (bilaPani[0] - televize[0]) < (bilaPani[1] - televize[1]):
			direction = "left"
		else:
			direction = "up"
	elif televize[1] > bilaPani[1]:
		direction = "right"
	elif televize[1] < bilaPani[1]:
		direction = "left"
	return direction


def createWindowProp():
	global box_width, box_height, window_width, window_height, fps, fpsClock, font, televizeImage, bilaPaniImage
	window_width = 640
	window_height = 480	
	font = pygame.font.SysFont("arial", window_width/40)
	fpsClock = pygame.time.Clock()
	fps = 30
	televizeImage = pygame.image.load("televize.bmp")
	bilaPaniImage = pygame.image.load("bilapani.bmp")


def createWindow():
	global window
	window = pygame.display.set_mode((window_width, window_height), 0, 32)
	pygame.display.set_caption('Bílá Paní')


def scaleImages():
	global televizeImageSmall, bilaPaniImageSmall
	televizeImageSmall = pygame.transform.scale(televizeImage, (box_width - 4, box_height - 4))
	bilaPaniImageSmall = pygame.transform.scale(bilaPaniImage, (box_width - 4, box_height - 4))


def drawBludiste():
	for y in range(vyska_pole):
		for x in range(sirka_pole):
			coord = [y, x]
			if coord in zdi:
				temp = pygame.Rect(window.get_rect().left + (x * (box_width - 4)) + 2 + (+ 2 * x), window.get_rect().top + (y * (box_height - 4)) + 2 + (+ 2 * y), box_width - 4, box_height - 4)
				pygame.draw.rect(window, RED, temp)
			else:
				temp = pygame.Rect(window.get_rect().left + (x * (box_width - 4)) + 2 + (+ 2 * x), window.get_rect().top + (y * (box_height - 4)) + 2 + (+ 2 * y), box_width - 4, box_height - 4)
				pygame.draw.rect(window, WHITE, temp)
			if coord == bilaPani:
				window.blit(bilaPaniImageSmall, temp)
			elif coord == televize:
				window.blit(televizeImageSmall, temp)
			del(temp)


def krok():
	global bilaPani, historyList
	direction = getDirection()
	print(direction)
	print("pre-Pos = " + str(bilaPani))
	if direction == "down":
		if not [bilaPani[0] + 1, bilaPani[1]] in zdi and not [bilaPani[0] + 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] + 1
			print("a")
		elif (televize[1] - bilaPani[1]) > (bilaPani[1] - televize[1]) and not [bilaPani[0], bilaPani[1] + 1] in zdi and not [bilaPani[0], bilaPani[1] + 1] in historyList:
			bilaPani[1] = bilaPani[1] + 1
			print("b")
		elif not [bilaPani[0], bilaPani[1] - 1] in zdi and not [bilaPani[0], bilaPani[1] - 1] in historyList:
			bilaPani[1] = bilaPani[1] - 1
			print("c")
		else:
			if not [bilaPani[0], bilaPani[1] - 1] in zdi and not [bilaPani[0], bilaPani[1] - 1 ] in historyList and [bilaPani[0], bilaPani[1] + 1] in zdi:
				bilaPani[1] = bilaPani[1] - 1
				print("d")
			elif not [bilaPani[0], bilaPani[1] + 1] in zdi and not [bilaPani[0], bilaPani[1] + 1 ] in historyList and [bilaPani[0], bilaPani[1] - 1] in zdi:
				bilaPani[1] = bilaPani[1] + 1
				print("e")
			elif not [bilaPani[0], bilaPani[1] + 1] in zdi and not [bilaPani[0], bilaPani[1] + 1] in historyList and not [bilaPani[0], bilaPani[1] - 1] in zdi and not [bilaPani[0], bilaPani[1] - 1] in historyList:
				tempRand = rand.randint(0, 1)
				if tempRand == 1:
					bilaPani[1] = bilaPani[1] + 1
					print("f")
				else:
					bilaPani[1] = bilaPani[1] - 1
					print("g")
			elif not [bilaPani[0] - 1, bilaPani[1]] in zdi:
					bilaPani[0] = bilaPani[0] - 1
					print("e")
			elif [bilaPani[0], bilaPani[1] - 1] in historyList and not [bilaPani[0], bilaPani[1] + 1] in zdi:
				bilaPani[1] = bilaPani[1] + 1
				print("f")
			elif [bilaPani[0], bilaPani[1] + 1] in historyList and not [bilaPani[0], bilaPani[1] - 1] in zdi:
				bilaPani[1] = bilaPani[1] - 1
				print("g")
			elif [bilaPani[0] + 1, bilaPani[1]] is historyList[-1] and not [bilaPani[0], bilaPani[1] - 1] in zdi:
				bilaPani[1] = bilaPani[1] - 1
				print("h")
			elif [bilaPani[0] + 1, bilaPani[1]] is historyList[-1] and not [bilaPani[0], bilaPani[1] + 1] in zdi:
				bilaPani[1] = bilaPani[1] + 1
				print("i")
			elif [bilaPani[0] + 1, bilaPani[1]] is historyList[-1] and not [bilaPani[0] - 1, bilaPani[1]] in zdi:
				bilaPani[0] = bilaPani[0] - 1
				print("j")
			else:
				print("can't find way")
				
	elif direction == "up":
		if not [bilaPani[0] - 1, bilaPani[1]] in zdi and not [bilaPani[0] - 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] - 1
			print("d")
		elif (televize[1] - bilaPani[1]) > (bilaPani[1] - televize[1]) and not [bilaPani[0], bilaPani[1] + 1] in zdi and not [bilaPani[0], bilaPani[1] + 1] in historyList:
			bilaPani[1] = bilaPani[1] + 1
		elif not [bilaPani[0], bilaPani[1] - 1] in zdi and not [bilaPani[0], bilaPani[1] - 1] in historyList:
			bilaPani[1] = bilaPani[1] - 1
			
	elif direction == "right":
		if not [bilaPani[0] + 1, bilaPani[1]] in zdi and not [bilaPani[0] + 1, bilaPani[1]] in historyList:
			bilaPani[1] = bilaPani[1] + 1
		elif (televize[0] - bilaPani[0]) > (bilaPani[0] - televize[0]) and not [bilaPani[0] + 1, bilaPani[1]] in zdi and not [bilaPani[0] + 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] + 1
		elif not [bilaPani[0] - 1, bilaPani[1]] in zdi and not [bilaPani[0] - 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] - 1
			
	elif direction == "left":
		if not [bilaPani[0] - 1, bilaPani[1]] in zdi and not [bilaPani[0] - 1, bilaPani[1]] in historyList:
			bilaPani[1] = bilaPani[1] - 1
		elif (televize[0] - bilaPani[0]) > (bilaPani[0] - televize[0]) and not [bilaPani[0] + 1, bilaPani[1]] in zdi and not [bilaPani[0] + 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] + 1
		elif not [bilaPani[0] - 1, bilaPani[1]] in zdi and not [bilaPani[0] - 1, bilaPani[1]] in historyList:
			bilaPani[0] = bilaPani[0] - 1
	print("pos = " + str(bilaPani))
	historyList.append([bilaPani[0], bilaPani[1]])
	print("list = " + str(historyList))
	print([bilaPani[0], bilaPani[1] + 1])
	

	#elif x == "next":
	#	index += 1
	#	return historyList[index]
	#elif x == "prev":
	#	if index >= 1:
	#		index -= 1
	#	return historyList[index]


def createHistory():
	global historyList, index
	historyList = []	
	historyList.append([bilaPani[0], bilaPani[1]])
	index = 0
	
	
	
###################PROGRAM##############
global RED, GREEN, Blue, Black, WHITE, GREY
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
GREY = (124,124,124)

createWindowProp()
nactiZaklad()
createHistory()
scaleImages()
createWindow()
running = True
while running == True:
	for event in pygame.event.get():
		if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
			pygame.quit()
			running = False
		if event.type == KEYDOWN:
			if (event.key == K_RIGHT or event.key == K_SPACE) and bilaPani != televize:
				krok()
				print("---------------KROK------------------")
	window.fill(BLACK)
	drawBludiste()
	pygame.display.update()
	fpsClock.tick(fps)
