# -*- coding: cp1250 -*-
import pygame, sys, time, random
from pygame.locals import *
pygame.init()

def vytvor_pole(text):
    global vyska_pole, sirka_pole
    text = text.split("\n")
    text[0] = text[0].split(" ")
    vyska_pole = int(text[0][1])
    sirka_pole = int(text[0][0])
    del text[0]
    for index in range(len(text)):
        text[index] = list(text[index])
    return(text)
mod = raw_input("""Zvolte md:
1)Editace bludit
2)Spusit bludit
: """)
soubor = raw_input("Zadejte nzev natanho souboru: ")
soubor = open("vstup1.in", "r")
text = soubor.read().rstrip()

pole = vytvor_pole(text)


# barvy
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
GREY = (124,124,124)
window_width = 640
window_height = 480
window = pygame.display.set_mode((window_width, window_height))
font = pygame.font.SysFont("arial", window_height/vyska_pole)
text_font = pygame.font.SysFont("arial", window_width/40)
fpsClock = pygame.time.Clock()
fps = 30
box_width = window_width/sirka_pole
box_height = window_height/vyska_pole

def is_in_rectangle(point, rect):
    if point[0] >= rect.left and point[0] <= rect.right and point[1] >= rect.top and point[1] <= rect.bottom:
        return(True)
    return(False)



def nove_pole(pole):
    for y in range(vyska_pole):
        for x in range(sirka_pole):
            pole[y][x] = "."
    pole[0][0] = "&"
    pole[vyska_pole-1][sirka_pole-1] = "#"
    return(pole)

def zobraz_znak(znak, souradnice):
    text = font.render(znak, True, WHITE)
    text_rect = text.get_rect()
    text_rect.left = souradnice[0]*box_width
    text_rect.top = souradnice[1]*box_height
    window.blit(text, text_rect)

def zobraz_pole(pole):
    for y in range(vyska_pole):
        for x in range(sirka_pole):
            if pole[y][x] != ".":
                zobraz_znak(pole[y][x], (x, y))
   
def najdi_objekty(pole):
    global zdi, zvedove, bila_pani, televizor
    zdi = []
    zvedove = []
    for y in range(vyska_pole):
        for x in range(sirka_pole):
            if pole[y][x] == "&":
                bila_pani = [x, y]
            elif pole[y][x] == "X":
                zdi.append((x, y))
            elif pole[y][x] == "#":
                televizor = (x, y)
            elif pole[y][x] == "@":
                zvedove.append((x, y))

    for x in (-1, sirka_pole):
        for y in range(-1, vyska_pole+1):
            zdi.append((x, y))
    for y in (-1, vyska_pole):
        for x in range(-1, sirka_pole+1):
            zdi.append((x, y))
            
def krok(bila_pani):
    global smer
    """
    
    smer = ["", ""]
    
    if bila_pani[0] < televizor[0]:
        smer[0] = "right"
    else:
        smer[0] = "left"
    if bila_pani[1] < televizor[1]:
        smer[1] = "down"
    else:
        smer[1] = "up"

    if smer[0] == "right":
        if (nova_pani[0]+1, nova_pani[1]) not in zdi:       #Kdy tam neni ze
            nova_pani[0] += 1
    
        elif smer[1] == "down":
            if (nova_pani[0], nova_pani[1]+1) not in zdi:
                nova_pani[1] += 1
            elif (nova_pani[0], nova_pani[1]-1) not in zdi:
                nova_pani[1] -= 1
        elif smer[1] == "up":
            if (nova_pani[0], nova_pani[1]-1) not in zdi:
                nova_pani[1] -= 1
            elif (nova_pani[0], nova_pani[1]+1) not in zdi:
                nova_pani[1] += 1
        if nova_pani == bila_pani and (nova_pani[0]-1, nova_pani[1]) not in zdi:
            nova_pani[0] -= 1
    elif smer[0] == "left":
        if (nova_pani[0]-1, nova_pani[1]) not in zdi:       #Kdy tam neni ze
            nova_pani[0] -= 1
    
        elif smer[1] == "down":
            if (nova_pani[0], nova_pani[1]+1) not in zdi:
                nova_pani[1] += 1
            elif (nova_pani[0], nova_pani[1]-1) not in zdi:
                nova_pani[1] -= 1
        elif smer[1] == "up":
            if (nova_pani[0], nova_pani[1]-1) not in zdi:
                nova_pani[1] -= 1
            elif (nova_pani[0], nova_pani[1]+1) not in zdi:
                nova_pani[1] += 1
        if nova_pani == bila_pani and (nova_pani[0]+1, nova_pani[1]) not in zdi:
            nova_pani[0] += 1
    print(nova_pani)
    return(nova_pani)
    """
    nova_pani = [bila_pani[0], bila_pani[1]]
    pricteno = False
    if (nova_pani[0]-1, nova_pani[1]+1) in zdi and (nova_pani[0], nova_pani[1]+1) not in zdi and smer == "down":    
        nova_pani[1] += 1
        pricteno = True
    elif (nova_pani[0]+1, nova_pani[1]+1) in zdi and (nova_pani[0]+1, nova_pani[1]) not in zdi and smer == "right":
        nova_pani[0] += 1
        pricteno = True
    elif (nova_pani[0]+1, nova_pani[1]-1) in zdi and (nova_pani[0], nova_pani[1]-1) not in zdi and smer == "up":
        nova_pani[1] -= 1
        pricteno = True
    elif (nova_pani[0]-1, nova_pani[1]-1) in zdi and (nova_pani[0]-1, nova_pani[1]) not in zdi and smer == "left":
        nova_pani[0] -= 1
        pricteno = True
    
    if pricteno == False:      #Kdy nen mono pokraovat aktulnm smrem
        if (nova_pani[0]-1, nova_pani[1]+1) in zdi and (nova_pani[0], nova_pani[1]+1) not in zdi:
            if smer != "up":
                smer = "down"
                nova_pani[1] += 1
        elif (nova_pani[0]+1, nova_pani[1]+1) in zdi and (nova_pani[0]+1, nova_pani[1]) not in zdi:
            if smer != "left":
                smer = "right"
                nova_pani[0] += 1
        elif (nova_pani[0]+1, nova_pani[1]-1) in zdi and (nova_pani[0], nova_pani[1]-1) not in zdi:
            if smer != "down":
                smer = "up"
                nova_pani[1] -= 1
        elif (nova_pani[0]-1, nova_pani[1]-1) in zdi and (nova_pani[0]-1, nova_pani[1]) not in zdi:
            if smer != "right":
                smer = "left"
                nova_pani[0] -= 1
    print(nova_pani)
    return(nova_pani)

if mod == "2":
    smer = "down"
    najdi_objekty(pole)
    running = True
    while running == True:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                sys.exit()
            if event.type == KEYDOWN:
                if event.key == K_RIGHT or event.key == K_SPACE:
                    nova_pani = krok(bila_pani)
                    print(smer)
                    if nova_pani == bila_pani:
                        running = "blokace"
                    else:
                        pole[bila_pani[1]][bila_pani[0]] = "."
                        bila_pani = [nova_pani[0], nova_pani[1]]
                        pole[bila_pani[1]][bila_pani[0]] = "&"
                    
        window.fill(BLACK)
        zobraz_pole(pole)
        pygame.display.update()
        fpsClock.tick(fps)

    text = text_font.render("Nelze se pohnout", True, RED)
    text_rect = text.get_rect()
    text_rect.centerx = window_width/2
    text_rect.centery = window_height/2
    window.blit(text, text_rect)

    while True:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                sys.exit()
        pygame.display.update()
        fpsClock.tick(fps)
elif mod == "1":
    window = pygame.display.set_mode((int(window_width*1.3), window_height))
    font2 = pygame.font.SysFont("arial", 30)
    nove_pole_text = font2.render("Nov Pole", True, RED, GREEN)
    nove_pole_rect = nove_pole_text.get_rect()
    nove_pole_rect.right = int(window_width*1.3)
    nove_pole_rect.bottom = window_height
    
    while True:
        window.fill(GREY)
        pygame.draw.rect(window, BLACK, (0, 0, window_width*0.9, window_height))
        window.blit(nove_pole_text, nove_pole_rect)
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                soubor = raw_input("Zadejte nzev souboru, kam chcete pole uloit: ")
                f = open(soubor, "w")
                f.write(str(vyska_pole)+ " "+ str(sirka_pole) + "\n")
                for radek in pole:
                    for znak in radek:
                        f.write(znak)
                    f.write("\n")
                f.close()
                print("Soubor byl uloen!")
                exit()
            if event.type == MOUSEMOTION:
                mouse_position = event.pos
            if event.type == MOUSEBUTTONDOWN and event.button == 1:
                if is_in_rectangle(mouse_position, nove_pole_rect):
                    pole= nove_pole(pole)
        
        zobraz_pole(pole)
        pygame.display.update()
        fpsClock.tick(fps)
