#!/usr/bin/env python3
# -*- coding:utf-8 -*-

def pyramida(vyska):
	i = 1
	kostky = 0
	radek = 0
	while i != int(vyska) + 1:
		radek = radek + 1 
		# vime ze plati ze pocet kvadru v danem patre je o jedna vetsi nez pocet kvadru v predchozim patre
		kostky = kostky + radek 
		# celkovy pocet kvadru nutny pro stavbu
		i = i + 1
		#kontrolor vysky 
	return kostky, radek
		

def draw(radek, vyska):
	space = ""
	if int(vyska) > 66:
		exit("ERR: Tuto vysku neni mozne zobrazit pri aktualnim displeji")
	if int(vyska) > 33:
		pattern = "X"
		firstSpace = " "
	else:
		firstSpace = "  "
		pattern = "XXX"
	kvadr = pattern + "|"
	out = []
	while radek != 0:
		out = [(space + "|" + pattern + "|" + kvadr * (radek - 1))] + out
		space = space + firstSpace
		radek = radek - 1
	#protoze uz zname pocet kvadru v poslednim radku neni potreba jej znovu pocitat
	#a proto postupujeme od zakladny pyramidy k jejimu vrcholu
	for i in out:
		print(i)

###########################################

vyska = raw_input("zadej velikost pyramidy: ")
kostek, radek = pyramida(vyska)
print("Pro stavbu bude potreba " + str(kostek) + " kvadru")
draw(radek, vyska)

#Copyright Filip Dobrovolny 2013 (c)